/*
 * Copyright (C) 2003  Diez B. Roggisch [deets@web.de]
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: TextAreaFormElement.java 114 2005-12-09 15:51:51Z christianc $
 */
package org.barracudamvc.contrib.dbroggisch.repopulation;

import org.barracudamvc.core.comp.BText;
import org.barracudamvc.core.comp.ViewContext;
import org.barracudamvc.core.forms.DefaultFormElement;

public class TextAreaFormElement extends DefaultFormElement implements RepopulationElement {

    //  boolean _allow_markup;

    public TextAreaFormElement(java.lang.String name, org.barracudamvc.core.forms.FormType ft, Object defaultVal) {
                               //, boolean allow_markup) {
        super(name, ft, defaultVal);
        //      _allow_markup = allow_markup;
    }


    public Object render(ViewContext context) {
        BText bt = new BText();
        Object val = getOrigVal();
        if(val != null) {
            bt.setText("" + val);
        }
//      if(_allow_markup) {
//          bt.setAllowMarkupInText(true);
//      }
        return bt;
    }
}

