/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.barracudamvc.contrib.sam.xmlform.dtd;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.ext.LexicalHandler;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

public class FormImpl extends DefaultHandler implements Cloneable, Unmarshallable, LexicalHandler, Form {

    private List ref_idList;
    private InsertBefore insertBefore;
    private AppendChild appendChild;
    private List elementList;
    private List validatorList;
    private String repeat_prefix;
    private boolean zeus_Repeat_prefixSet;

    /** Any DOCTYPE reference/statements. */
    private String docTypeString;

    /** The encoding for the output document */
    private String outputEncoding;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** Whether a DTD exists for an unmarshal call */
    private boolean hasDTD;

    /** Whether validation is occurring */
    private boolean validate;

    /** The namespace mappings on this element */
    private Map namespaceMappings;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    private static FormImpl prototype = null;

    public static void setPrototype(FormImpl prototype) {
        FormImpl.prototype = prototype;
    }
    public static FormImpl newInstance() {
        try {
            return (prototype!=null)?(FormImpl)prototype.clone(): new FormImpl();
        } catch (CloneNotSupportedException e) {
            return null; // never
        }
    }
    public FormImpl() {
        ref_idList = new LinkedList();
        elementList = new LinkedList();
        validatorList = new LinkedList();
        zeus_Repeat_prefixSet = false;
        docTypeString = "";
        hasDTD = false;
        validate = false;
        namespaceMappings = new HashMap();
    }

    public List getRef_idList() {
        return ref_idList;
    }

    public void setRef_idList(List ref_idList) {
        this.ref_idList = ref_idList;
    }

    public void addRef_id(Ref_id ref_id) {
        ref_idList.add(ref_id);
    }

    public void removeRef_id(Ref_id ref_id) {
        ref_idList.remove(ref_id);
    }

    public InsertBefore getInsertBefore() {
        return insertBefore;
    }

    public void setInsertBefore(InsertBefore insertBefore) {
        this.insertBefore = insertBefore;
    }

    public AppendChild getAppendChild() {
        return appendChild;
    }

    public void setAppendChild(AppendChild appendChild) {
        this.appendChild = appendChild;
    }

    public List getElementList() {
        return elementList;
    }

    public void setElementList(List elementList) {
        this.elementList = elementList;
    }

    public void addElement(Element element) {
        elementList.add(element);
    }

    public void removeElement(Element element) {
        elementList.remove(element);
    }

    public List getValidatorList() {
        return validatorList;
    }

    public void setValidatorList(List validatorList) {
        this.validatorList = validatorList;
    }

    public void addValidator(Validator validator) {
        validatorList.add(validator);
    }

    public void removeValidator(Validator validator) {
        validatorList.remove(validator);
    }

    public String getRepeat_prefix() {
        return repeat_prefix;
    }

    public void setRepeat_prefix(String repeat_prefix) {
        this.repeat_prefix = repeat_prefix;
        zeus_Repeat_prefixSet = true;
    }

    public void setDocType(String name, String publicID, String systemID) {
        try {
            startDTD(name, publicID, systemID);
        } catch (SAXException neverHappens) { }
    }

    public void setOutputEncoding(String outputEncoding) {
        this.outputEncoding = outputEncoding;
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" ");
        if (outputEncoding != null) {
            writer.write("encoding=\"");
            writer.write(outputEncoding);
            writer.write("\"?>\n\n");

        } else {
            writer.write("encoding=\"UTF-8\"?>\n\n");

        }
        // Handle DOCTYPE declaration
        writer.write(docTypeString);
        writer.write("\n");
        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<form");

        // Handle namespace mappings (if needed)
        for (Iterator i = namespaceMappings.keySet().iterator(); i.hasNext(); ) {
            String prefix = (String)i.next();
            String uri = (String)namespaceMappings.get(prefix);
            writer.write(" xmlns");
            if (!prefix.trim().equals("")) {
                writer.write(":");
                writer.write(prefix);
            }
            writer.write("=\"");
            writer.write(uri);
            writer.write("\"\n        ");
        }

        // Handle attributes (if needed)
        if (zeus_Repeat_prefixSet) {
            writer.write(" repeat_prefix=\"");
            writer.write(escapeAttributeValue(repeat_prefix));
            writer.write("\"");
        }
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        for (Iterator i=ref_idList.iterator(); i.hasNext(); ) {
            Ref_idImpl ref_id = (Ref_idImpl)i.next();
            ref_id.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        if (insertBefore != null) {
            ((InsertBeforeImpl)insertBefore).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (appendChild != null) {
            ((AppendChildImpl)appendChild).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=elementList.iterator(); i.hasNext(); ) {
            ElementImpl element = (ElementImpl)i.next();
            element.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=validatorList.iterator(); i.hasNext(); ) {
            ValidatorImpl validator = (ValidatorImpl)i.next();
            validator.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        writer.write(indent);
        writer.write("</form>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    private String escapeTextValue(String textValue) {
        String returnValue = textValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '<') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&lt;")
                    .append(returnValue.substring(i+1))
                    .toString();
            } else if (ch == '>') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&gt;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static Form unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static Form unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static Form unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static Form unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static Form unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static Form unmarshal(Reader reader, boolean validate) throws IOException {
        FormImpl form = FormImpl.newInstance();
        form.setValidating(validate);
        form.setCurrentUNode(form);
        form.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;

        try {
            parser = XMLReaderFactory.createXMLReader();

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler
            parser.setErrorHandler(form);

            // Register lexical handler
            parser.setProperty("http://xml.org/sax/properties/lexical-handler", form);

            // Register content handler
            parser.setContentHandler(form);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.setFeature("http://xml.org/sax/features/namespaces", true);
            parser.setFeature("http://xml.org/sax/features/namespace-prefixes", false);
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return form;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void setValidating(boolean validate) {
        this.validate = validate;
    }

    public void startDocument() throws SAXException {
        // no-op
    }

    public void setDocumentLocator(Locator locator) {
        // no-op
    }

    public void startPrefixMapping(String prefix, String uri)
        throws SAXException {
        namespaceMappings.put(prefix, uri);
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, org.xml.sax.Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("form")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
                if (attName.equals("repeat_prefix")) {
                    setRepeat_prefix(attValue);
                }
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("ref_id")) {
                Ref_idImpl ref_id = Ref_idImpl.newInstance();
                current = getCurrentUNode();
                ref_id.setParentUNode(current);
                ref_id.setCurrentUNode(ref_id);
                this.setCurrentUNode(ref_id);
                ref_id.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                ref_idList.add(ref_id);
                return;
            }
            if (localName.equals("insertBefore") && (insertBefore==null)) {
                InsertBeforeImpl insertBefore = InsertBeforeImpl.newInstance();
                current = getCurrentUNode();
                insertBefore.setParentUNode(current);
                insertBefore.setCurrentUNode(insertBefore);
                this.setCurrentUNode(insertBefore);
                insertBefore.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.insertBefore = insertBefore;
                return;
            }
            if (localName.equals("appendChild") && (appendChild==null)) {
                AppendChildImpl appendChild = AppendChildImpl.newInstance();
                current = getCurrentUNode();
                appendChild.setParentUNode(current);
                appendChild.setCurrentUNode(appendChild);
                this.setCurrentUNode(appendChild);
                appendChild.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.appendChild = appendChild;
                return;
            }
            if (localName.equals("element")) {
                ElementImpl element = ElementImpl.newInstance();
                current = getCurrentUNode();
                element.setParentUNode(current);
                element.setCurrentUNode(element);
                this.setCurrentUNode(element);
                element.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                elementList.add(element);
                return;
            }
            if (localName.equals("validator")) {
                ValidatorImpl validator = ValidatorImpl.newInstance();
                current = getCurrentUNode();
                validator.setParentUNode(current);
                validator.setCurrentUNode(validator);
                this.setCurrentUNode(validator);
                validator.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                validatorList.add(validator);
                return;
            }
        }
    }

    public void endElement(String namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
        text = text.trim();
    }

    public void comment(char ch[], int start, int len) throws SAXException {
        // Currently no-op
    }

    public void warning(SAXParseException e) throws SAXException {
        if (errorHandler != null) {
            errorHandler.warning(e);
        }
    }

    public void error(SAXParseException e) throws SAXException {
        if ((validate) && (!hasDTD)) {
            throw new SAXException("Validation is turned on, but no DTD has been specified in the input XML document. Please supply a DTD through a DOCTYPE reference.");
        }
        if (errorHandler != null) {
            errorHandler.error(e);
        }
    }

    public void fatalError(SAXParseException e) throws SAXException {
        if ((validate) && (!hasDTD)) {
            throw new SAXException("Validation is turned on, but no DTD has been specified in the input XML document. Please supply a DTD through a DOCTYPE reference.");
        }
        if (errorHandler != null) {
            errorHandler.fatalError(e);
        }
    }

    public void startDTD(String name, String publicID, String systemID)
        throws SAXException {

        if ((name == null) || (name.equals(""))) {
            docTypeString = "";
            return;
        }

        hasDTD = true;
        StringBuffer docTypeSB = new StringBuffer();
        boolean hasPublic = false;

        docTypeSB.append("<!DOCTYPE ")
                 .append(name);

        if ((publicID != null) && (!publicID.equals(""))) {
            docTypeSB.append(" PUBLIC \"")
                     .append(publicID)
                     .append("\"");
            hasPublic = true;
        }

        if ((systemID != null) && (!systemID.equals(""))) {
            if (!hasPublic) {
                docTypeSB.append(" SYSTEM");
            }
            docTypeSB.append(" \"")
                     .append(systemID)
                     .append("\"");

        }

        docTypeSB.append(">");

        docTypeString = docTypeSB.toString();
    }

    public void endDTD() throws SAXException {
        // Currently no-op
    }

    public void startEntity(String name) throws SAXException {
        // Currently no-op
    }

    public void endEntity(String name) throws SAXException {
        // Currently no-op
    }

    public void startCDATA() throws SAXException {
        // Currently no-op
    }

    public void endCDATA() throws SAXException {
        // Currently no-op
    }

}
